## tango 9.5.0+dfsg1

=== CMakeLists.txt ===
# vim: noautoindent:
cmake_minimum_required(VERSION 3.18...3.26 FATAL_ERROR)

project(TangoSourceDistribution LANGUAGES CXX)

include(FindPkgConfig)

set(SHELL "/usr/bin/env sh")

get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)

if(NOT IS_MULTI_CONFIG AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

# switches
option(TSD_LIB "Install and use bundled libtango, if OFF use libtango found on system" ON)
option(TSD_JAVA "Installation of java applications" ON)
option(TSD_DATABASE "Installation of tango database server" ON)
option(TSD_TAC "Installation of access control server" OFF)
option(TSD_HTML_DOCUMENTATION "Include the HTML documentation" ON)

# non-boolean knobs
SET(TSD_JAVA_PATH "" CACHE STRING "Path to the java interpreter")

if(TSD_JAVA)
  set(JAVA_HOME ${TSD_JAVA_PATH})

  find_package(Java 11 COMPONENTS Runtime REQUIRED)

  set(TSD_JAVA_VERSION ${Java_VERSION_STRING})
  set(TSD_JAVA_EXEC ${Java_JAVA_EXECUTABLE})
else()
  set(TSD_JAVA_VERSION "unknown")
  set(TSD_JAVA_EXEC "unknown")
endif()

SET(TSD_RC_FILE "/etc/tangorc")

# Overwrite settings of included projects
option(BUILD_TESTING "Enable building the cppTango tests" OFF)

# The nasty part, overwrite future invocations of pkg-config calls with code
# we are just about to compile and install
pkg_search_module(IDL_PKG tangoidl)
set(IDL_PKG_FOUND ON)
set(IDL_PKG_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/lib/idl")

add_subdirectory(lib)
if (TSD_LIB)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/lib/cpp/configure)

  # Find dependent libraries of cppTango
  find_package(omniORB4 REQUIRED)
  find_package(cppzmq REQUIRED)

  if(TANGO_USE_JPEG)
    find_package(JPEG REQUIRED)
  endif()

  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
endif()

add_subdirectory(cppserver)
add_subdirectory(doc)
add_subdirectory(pogo)

if(TSD_DATABASE)
  add_subdirectory(scripts)
endif()

add_subdirectory(utils)

# mysql/mariadb server is found in TangoDatabase cmake logic

if(OMNIORB_PKG_FOUND)
  set(TSD_OMNIORB_VERSION ${OMNIORB_PKG_VERSION})
  set(TSD_OMNIORB_PATH ${OMNIORB_PKG_PREFIX})
else()
  # TODO Get omniORB version, see https://stackoverflow.com/a/47084079
  # $grep VERSION /usr/include/omniORB4/acconfig.h
  # define PACKAGE_VERSION "4.2.2"
  set(TSD_OMNIORB_VERSION "not-yet-supported")
  set(TSD_OMNIORB_PATH ${TANGO_OMNI_BASE})
endif()

if(ZMQ_PKG_FOUND)
  set(TSD_ZMQ_VERSION ${ZMQ_PKG_VERSION})
  set(TSD_ZMQ_PATH ${ZMQ_PKG_PREFIX})
else()
  # TODO Get ZMQ version
  set(TSD_ZMQ_VERSION "not-yet-supported")
  set(TSD_ZMQ_PATH ${TANGO_ZMQ_BASE})
endif()

# Unfortunately, TangoDatabase's FindMySQL.cmake does not cache MySQL_LIBRARY,
# only MySQL_LIBRARY_RELEASE and MySQL_LIBRARY_DEBUG.
if (NOT MySQL_LIBRARY)
  include(SelectLibraryConfigurations)
  select_library_configurations(MySQL)
endif()

set(TSD_MYSQL_CLIENT_LDLIBS ${MySQL_LIBRARY})
set(TSD_MYSQL_CLIENT_VERSION ${MySQL_VERSION})
set(TSD_MYSQL_SERVER_VERSION ${TDB_DB_VERSION})
set(TSD_MYSQL_SERVER_CONNECTION ${TDB_DB_CONNECTION_RESULT})

message(STATUS                                                                                                               "\
Summary:                                                                                                                   \n \
Configuration (TangoSourceDistribution):                                                                                   \n \
                                                                                                                           \n \
Source code location: ${CMAKE_SOURCE_DIR}                                                                                  \n \
Version: 9.5.0                                                                                                     \n \
Compiler: C++ ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}                                                       \n \
                                                                                                                           \n \
OMNIORB PATH: ${TSD_OMNIORB_PATH}                                                                                          \n \
OMNIORB VERSION: ${TSD_OMNIORB_VERSION}                                                                                    \n \
                                                                                                                           \n \
ZMQ PATH: ${TSD_ZMQ_PATH}                                                                                                  \n \
ZMQ VERSION: ${TSD_ZMQ_VERSION}                                                                                            \n \
                                                                                                                           \n \
JAVA PATH: ${TSD_JAVA_EXEC}                                                                                                \n \
JAVA VERSION: ${TSD_JAVA_VERSION}                                                                                          \n \
                                                                                                                           \n \
Database:                                                                                                                  \n \
                                                                                                                           \n \
DB NAME: ${TANGO_DB_NAME}                                                                                                  \n \
CLIENT LIB: ${TSD_MYSQL_CLIENT_LDLIBS}                                                                                     \n \
CLIENT VERSION: ${TSD_MYSQL_CLIENT_VERSION}                                                                                \n \
SERVER VERSION: ${TSD_MYSQL_SERVER_VERSION}                                                                                \n \
CONNECTION: ${TSD_MYSQL_SERVER_CONNECTION}                                                                                 \n \
                                                                                                                           \n \
Build:                                                                                                                     \n \
                                                                                                                           \n \
libraries:              ${TSD_LIB}                                                                                         \n \
java application :      ${TSD_JAVA}                                                                                        \n \
access control server:  ${TSD_TAC}                                                                                         \n \
database server:        ${TSD_DATABASE}                                                                                    \n \
database schema create: ${TDB_DATABASE_SCHEMA}                                                                             \n \
                                                                                                                           \n \
Please check whether the configuration I detected matches what you would like to have.")

=== cppserver/CMakeLists.txt ===
message(STATUS "Database")
if(TSD_DATABASE)
  add_subdirectory(database)
  list(APPEND BATCH_SCRIPTS start-db.bat)
endif()

message(STATUS "Starter")
add_subdirectory(starter)
list(APPEND BATCH_SCRIPTS start-starter.bat)

message(STATUS "Access Control")
if(TSD_TAC)
  add_subdirectory(tangoaccesscontrol)
endif()

message(STATUS "Test")
add_subdirectory(tangotest)
list(APPEND BATCH_SCRIPTS start-tangotest.bat)

if (WIN32)
    foreach(input ${BATCH_SCRIPTS})
        install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/${input}
                DESTINATION ${CMAKE_INSTALL_BINDIR})
    endforeach()
endif()

=== doc/CMakeLists.txt ===
if (NOT WIN32)
    add_subdirectory(man)
endif()

if(TSD_HTML_DOCUMENTATION)
    add_subdirectory(html)
endif()

=== lib/CMakeLists.txt ===
if (TSD_LIB)
    message(STATUS "C++")
    add_subdirectory(cpp)
endif()

if(TSD_JAVA)
  message(STATUS "Java")
  add_subdirectory(java)
endif()

message(STATUS "IDL")
add_subdirectory(idl)

=== cppserver/database/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18...3.26 FATAL_ERROR)

project(DataBase VERSION 5.22.0 LANGUAGES CXX)

if(NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
endif()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include(configure/CMakeLists.txt)
include(test/CMakeLists.txt)

configure_file(cmake_config.h.in cmake_config.h @ONLY)

set(SOURCES DataBase.cpp
            DataBaseClass.cpp
            DatabaseConnectionHandle.cpp
            DatabaseConnectionPool.cpp
            DataBaseStateMachine.cpp
            ClassFactory.cpp
            main.cpp)

set(ADDITIONAL_SOURCES  DataBaseUtils.cpp
                        update_starter.cpp)

add_executable(Databaseds ${SOURCES} ${ADDITIONAL_SOURCES})
target_include_directories(Databaseds PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(Databaseds PUBLIC Tango::Tango MySQL::MySQL)

if (WIN32 AND (Tango_IS_STATIC OR Tango_FORCE_STATIC))
    set_target_properties(Databaseds PROPERTIES
        MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>"
    )
endif()

if (MSVC)
    target_compile_options(Databaseds PUBLIC /W3)
else()
    target_compile_options(Databaseds PUBLIC -Wall -Wextra -D_FORTIFY_SOURCE=2 -O1)
endif()


if(CMAKE_CXX_COMPILER_ID MATCHES ".*Clang")
    set_target_properties(Databaseds PROPERTIES LINK_FLAGS "-bind_at_load")
elseif(NOT MSVC)
    target_compile_options(Databaseds PUBLIC -fpie)
    set_target_properties(Databaseds PROPERTIES LINK_FLAGS "-Wl,-z,now -pie")
endif()


if(TDB_ENABLE_COVERAGE)
  target_link_options(Databaseds PUBLIC --coverage)
  target_compile_options(Databaseds PUBLIC --coverage)
endif()

install(TARGETS Databaseds
        RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}")

option(TANGO_WARNINGS_AS_ERRORS "Treat compiler warnings as errors" OFF)

if(TANGO_WARNINGS_AS_ERRORS)
    if (MSVC)
        target_compile_options(Databaseds PUBLIC /WX)
    else()
        target_compile_options(Databaseds PUBLIC -Werror -Wformat -Werror=format-security -pedantic)
    endif()
endif()

=== cppserver/starter/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18...3.26 FATAL_ERROR)
project(Starter VERSION 8.0 LANGUAGES CXX)

get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)

if(NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
endif()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

if(NOT CMAKE_BUILD_TYPE AND NOT IS_MULTI_CONFIG)
    message(STATUS "No build type specified - default is DEBUG")
    set(CMAKE_BUILD_TYPE DEBUG)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
find_package(Tango REQUIRED)

set(SOURCES CheckProcessUtil.cpp
            ClassFactory.cpp
            main.cpp
            PingThread.cpp
            Starter.cpp
            StarterClass.cpp
            StarterService.cpp
            StarterStateMachine.cpp
            StarterUtil.cpp
            StartProcessThread.cpp)

set(HEADER CheckProcessUtil.h
           Logging.h
           PingThread.h
           Starter.h
           StarterClass.h
           StarterService.h
           StarterUtil.h)

add_executable(Starter ${SOURCES} ${HEADER})
target_link_libraries(Starter PRIVATE Tango::Tango)

if (WIN32 AND (Tango_IS_STATIC OR Tango_FORCE_STATIC))
    set_target_properties(${PROJECT_NAME} PROPERTIES
        MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>"
    )
endif()

if (WIN32)
    # Starter requires WIN32 UNICODE string support see
    # https://learn.microsoft.com/en-us/cpp/text/unicode-programming-summary?view=msvc-170
    # and https://learn.microsoft.com/en-us/windows/win32/learnwin32/working-with-strings
    target_compile_definitions(Starter PUBLIC _UNICODE UNICODE)
endif()

if (MSVC)
    target_compile_options(Starter PUBLIC /W3)
else()
    target_compile_options(Starter PUBLIC -Wall -Wextra -D_FORTIFY_SOURCE=2 -O1)

    if(NOT (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
        target_compile_options(Starter PUBLIC -fpie)
        set_target_properties(Starter PROPERTIES LINK_FLAGS "-Wl,-z,now -pie")
    else()
        set_target_properties(Starter PROPERTIES LINK_FLAGS "-bind_at_load")
    endif()
endif()

install(TARGETS Starter
        RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}")

option(TANGO_WARNINGS_AS_ERRORS "Treat compiler warnings as errors" OFF)

if(TANGO_WARNINGS_AS_ERRORS)
    if (MSVC)
      target_compile_options(Starter PUBLIC /WX)
    else()
      target_compile_options(Starter PUBLIC -Werror -Wformat -Werror=format-security -pedantic)
    endif()
endif()

=== doc/man/CMakeLists.txt ===
project(man)

include(GNUInstallDirs)

set(MANPAGES astor.1
		         atkmoni.1
		         atkpanel.1
		         atktuning.1
		         jdraw.1
		         jive.1
		         logviewer.1
		         pogo.1
		         synopticappli.1)

foreach(input ${MANPAGES})
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${input}
          DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
endforeach()

=== lib/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18...3.26 FATAL_ERROR)
# minimum version: https://gitlab.com/tango-controls/docker/ci/cpptango/debian-minimum-versions
# maximum version: https://gitlab.com/tango-controls/docker/ci/cpptango/debian-maximum-cmake

project(cppTango LANGUAGES CXX
                 HOMEPAGE_URL "https://www.tango-controls.org"
                 DESCRIPTION "Distributed Control System")

if (NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include(CTest)

option(TANGO_WARNINGS_AS_ERRORS "Treat compiler warnings as errors" OFF)
option(BUILD_SHARED_LIBS "Build a shared library instead of static" ON)
option(TANGO_USE_LIBCPP "Build against libc++" OFF)

option(TANGO_ENABLE_COVERAGE "Instrument code for coverage analysis" OFF)
if (TANGO_ENABLE_COVERAGE AND NOT (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang"))
    message(WARNING "Code coverage is not supported for selected compiler.")
    set(TANGO_ENABLE_COVERAGE OFF)
endif()

set(TANGO_ENABLE_SANITIZER "" CACHE STRING "Enable sanitizer")
set(TANGO_SUPPORTED_SANITIZERS ASAN TSAN UBSAN MSAN)
set_property(CACHE TANGO_ENABLE_SANITIZER PROPERTY STRINGS ${TANGO_SUPPORTED_SANITIZERS})

if(TANGO_ENABLE_SANITIZER AND NOT (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang"))
    message(FATAL_ERROR "Sanitizers are not supported for selected compiler.")
endif()
if(TANGO_ENABLE_SANITIZER AND NOT (TANGO_ENABLE_SANITIZER IN_LIST TANGO_SUPPORTED_SANITIZERS))
    message(FATAL_ERROR "TANGO_ENABLE_SANITIZER must be one of: ${TANGO_SUPPORTED_SANITIZERS}.")
endif()
if(TANGO_ENABLE_SANITIZER STREQUAL "MSAN" AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    message(FATAL_ERROR "MSAN is not supported for selected compiler.")
endif()
if(TANGO_ENABLE_SANITIZER)
    find_program(ADDR2LINE_PROGRAM "addr2line")
    find_program(LLVM_SYMBOLIZER_PROGRAM "llvm-symbolizer")
    if(NOT ADDR2LINE_PROGRAM)
        message(FATAL_ERROR "Could not find addr2line (required for sanitizers).")
    endif()
    if(NOT LLVM_SYMBOLIZER_PROGRAM AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        message(FATAL_ERROR "Could not find llvm-symbolizer (required for sanitizers).")
    endif()
endif()

#need to define the version of the library
set(MAJOR_VERSION "9")
set(MINOR_VERSION "5")
set(PATCH_VERSION "0")

if(WIN32)
    include(configure/cmake_win_defs.cmake)
endif()

include(configure/git.cmake)
git_describe(GIT_DESCRIPTION SUFFIX_VERSION)

#convenient versions
set(LIBRARY_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}${SUFFIX_VERSION}")
set(SO_VERSION "${MAJOR_VERSION}${MINOR_VERSION}")

set(TANGO_GIT_REVISION "${GIT_DESCRIPTION}")

set(TANGO_HOST $ENV{TANGO_HOST})
include(configure/CMakeLists.txt)

SET(BUILD_TANGO_LOCAL_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src/include)
message(STATUS "Using ${BUILD_TANGO_LOCAL_INCLUDE_DIR} as build-time include directory")
include_directories(${BUILD_TANGO_LOCAL_INCLUDE_DIR})
include_directories(log4tango/include)
#required for generated include/tango/idl/tango.h, include/tango/common/tango_const.h and config.h
include_directories(${CMAKE_CURRENT_BINARY_DIR}/src/include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/log4tango/include)

#source code
add_subdirectory("log4tango")
add_subdirectory("src")

if(BUILD_TESTING)

  find_program(DOCKER_BINARY docker)
  if(NOT DOCKER_BINARY)
      message(WARNING "The tests can not be run as docker is missing.")
  endif()

  if(BUILD_SHARED_LIBS)
    add_subdirectory("tests")
  else()
    message(WARNING "Not building the tests, because that is currently supported only when BUILD_SHARED_LIBS is ON")
    set(BUILD_TESTING OFF)
  endif()
endif()


add_library(tango $<TARGET_OBJECTS:log4tango_objects>
                  $<TARGET_OBJECTS:common_objects>
                  $<TARGET_OBJECTS:client_objects>
                  $<TARGET_OBJECTS:idl_objects>
                  $<TARGET_OBJECTS:server_objects>)

target_link_libraries(tango
    PUBLIC
        ${CMAKE_DL_LIBS}
        omniORB4::omniORB4
        omniORB4::COS4
        omniORB4::Dynamic4
        cppzmq::cppzmq
    )

target_include_directories(tango PUBLIC
    ${cppzmq_INCLUDE_DIR}
    ${omniORB4_INCLUDE_DIR}
)

if(TANGO_USE_JPEG)
    target_link_libraries(tango PUBLIC JPEG::JPEG)
endif()

if(WIN32)
    include(configure/cmake_win.cmake)
    include(configure/cpack_win.cmake)
else()
    include(configure/cmake_linux.cmake)
endif()

include(CPack)

=== lib/idl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7 FATAL_ERROR)
project(tangoidl)
include(GNUInstallDirs)

#need to define the version of the library
set(MAJOR_VERSION "5")
set(MINOR_VERSION "0")
set(PATCH_VERSION "1")

#convenient versions
set(LIBRARY_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}")

install(FILES tango.idl DESTINATION "${CMAKE_INSTALL_FULL_INCLUDEDIR}")

configure_file(tangoidl.pc.cmake tangoidl.pc @ONLY)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/tangoidl.pc"
DESTINATION "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")

=== lib/java/CMakeLists.txt ===
project(java)

include(GNUInstallDirs)

find_package(Doxygen)
if(Doxygen_FOUND)
  set(DOXYGEN ${DOXYGEN_EXECUTABLE})
else()
  message(STATUS "Doxygen could not be found, pogo will therefore not be able to generate documentation")
endif()

if (NOT WIN32)
    set(SHELL_SCRIPTS astor
                    jive
                    pogo
                    atkpanel
                    logviewer
                    atktuning
                    jdraw
                    synopticappli
                    atkmoni
                    tg_devtest
                    TangoVers
                    TangoRestServer)

    foreach(input ${SHELL_SCRIPTS})
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${input}.in ${input} @ONLY)
        install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${input}
                DESTINATION ${CMAKE_INSTALL_BINDIR})
    endforeach()
else()
    set(BATCH_SCRIPTS
        start-astor.bat
        start-atkmoni.bat
        start-atkpanel.bat
        start-atktuning.bat
        start-jdraw.bat
        start-jive.bat
        start-logviewer.bat
        start-pogo.bat
        start-synoptic.bat
        atktuning_attributes.txt)

    foreach(input ${BATCH_SCRIPTS})
        install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/${input}
                DESTINATION ${CMAKE_INSTALL_BINDIR})
    endforeach()
endif()

set(CONFIG_XML logback-server.xml
               logback.xml)

foreach(input ${CONFIG_XML})
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${input}
          DESTINATION ${CMAKE_INSTALL_DATADIR}/tango)
endforeach()

# the following list of filenames is replaced with the real names by
# prepare-assets in build.xml, see also https://ant.apache.org/manual/Types/filterset.html
set(JAR_FILES Astor-7.4.4.jar
              ATKCore-9.3.28.jar
              ATKPanel-5.11.jar
              ATKTuning-4.8.jar
              ATKWidget-9.3.28.jar
              DBBench-1.4.jar
              Jive-7.36.jar
              JSSHTerminal-1.18.jar
              JTango-9.6.6.jar
              LogViewer-2.1.1.jar
              Pogo-9.8.0.jar)
if (NOT WIN32)
    list(APPEND JAR_FILES RestServer-1.22.jar)
endif()

foreach(input ${JAR_FILES})
  string(REGEX REPLACE "^([^-]+)-.*(\.jar)$" "\\1\\2" output ${input})
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${input}
          RENAME ${output}
          DESTINATION ${CMAKE_INSTALL_DATADIR}/java)
endforeach()

=== utils/tango_admin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18...3.26 FATAL_ERROR)

project(tango_admin VERSION 1.19 LANGUAGES CXX)

if (NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
find_package(Tango REQUIRED)

set(SOURCES
        tango_admin.cpp
        anyoption.cpp)

set(HEADERS
        anyoption.h)

add_executable(${PROJECT_NAME} ${SOURCES} ${HEADERS})
target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(${PROJECT_NAME} PUBLIC Tango::Tango ${CMAKE_DL_LIBS})

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION bin)

option(TANGO_WARNINGS_AS_ERRORS "Treat compiler warnings as errors" OFF)

if(TANGO_WARNINGS_AS_ERRORS)
  target_compile_options(${PROJECT_NAME} PUBLIC -Werror -Wall -Wextra -Wformat -Werror=format-security -pedantic)
endif()

=== cppserver/database/test/CMakeLists.txt ===
if(NOT BUILD_TESTING)
  return()
endif()

# Inspired by https://eb2.co/blog/2015/06/driving-boost.test-with-cmake
function(gather_boost_tests SOURCE_FILE_NAME)

    file(READ "${SOURCE_FILE_NAME}" SOURCE_FILE_CONTENTS)
    string(REGEX MATCHALL "BOOST_(AUTO|FIXTURE)_TEST_CASE\\([^,\\)]+"
           FOUND_TESTS ${SOURCE_FILE_CONTENTS})

    list(TRANSFORM FOUND_TESTS REPLACE ".*\\(([^,\\)]+).*" "\\1")

    set(ALL_TEST_CASES ${FOUND_TESTS} PARENT_SCOPE)
endfunction()

find_package(Boost REQUIRED unit_test_framework)

add_executable(db_test test/test.cpp)

target_include_directories(db_test PUBLIC ${Boost_INCLUDE_DIRS})
target_compile_options(db_test PUBLIC -Wall -Wextra -pedantic)
target_link_libraries(db_test ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} Tango::Tango)

configure_file(test/start_tdb.sh.in start_tdb.sh @ONLY)
configure_file(test/stop_tdb.sh.in stop_tdb.sh @ONLY)

gather_boost_tests("test/test.cpp")

# not using cmake FIXTURES_SETUP/FIXTURES_CLEANUP as these are not called per test case

message(STATUS "Found test cases: ${ALL_TEST_CASES}")

foreach(TEST_CASE IN LISTS ALL_TEST_CASES)
  add_test(NAME ${TEST_CASE} COMMAND db_test --log_level=all --logger=JUNIT,message,JU_${TEST_CASE}.xml:HRF,message,stdout --run_test=*/${TEST_CASE} --catch_system_error=yes)
  # don't allow parallel runs
  set_tests_properties(${TEST_CASE} PROPERTIES RESOURCE_LOCK Database)
endforeach()

=== debian/changelog ===
tango (9.5.0+dfsg1-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Santiago Ruano Rincón <santiago@freexian.com>  Tue, 09 Jan 2024 07:20:11 -0500

tango (9.5.0+dfsg1-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 9.5.0+dfsg1 (Closes: #1057877)
    * Import CMakeLists patches that fix finding the IDL path
    * Add d/patches/0001-tango_admin.cpp-Fix-ping-device-timeout-parsing.patch
      to fix regression in tango_admin --ping-device
      See: https://gitlab.com/tango-controls/tango_admin/-/issues/15
      Thanks to Thomas Braun
    * Update patches
  * Add Build-Depends on python3-sphinx-copybutton
  * d/rules: install migrate_db_tables_innodb.sql in tango-db
  * Bump SONAME to libtango95
  * Update d/copyright. Remove superfluous file patterns

 -- Santiago Ruano Rincón <santiago@freexian.com>  Fri, 15 Dec 2023 14:47:30 -0300

=== debian/control ===
Source: tango
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Picca Frédéric-Emmanuel <picca@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               default-libmysqlclient-dev,
               libcos4-dev,
               libjpeg-dev,
               cppzmq-dev,
               omniidl,
               po-debconf
Build-Depends-Indep: doxygen,
                     python3-ipython,
                     python3-sphinx,
                     python3-sphinx-copybutton,
                     python3-sphinx-rtd-theme
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/tango
Vcs-Git: https://salsa.debian.org/science-team/tango.git
Homepage: https://www.tango-controls.org
Rules-Requires-Root: no

Package: libtango95
Architecture: any
Multi-Arch: same
Section: libs
Depends: tango-common,
         ${misc:Depends},
         ${shlibs:Depends}
Description: TANGO distributed control system - shared library
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the files necessary for running TANGO applications.

Package: libtango-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcos4-dev,
         libtango95 (= ${binary:Version}),
         cppzmq-dev,
         libjpeg-dev,
         ${misc:Depends}
Conflicts: libtango7-dev, libtango8-dev
Description: TANGO distributed control system - development library
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the tango9 development files.

Package: libtango-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: TANGO distributed control system - documentation
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the documentation for the libtango95 library.

Package: libtango-tools
Architecture: any
Section: net
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: TANGO distributed control system - common executable files
 This package provides shared files for the TANGO distributed control
 system, and sets up the required infrastructure.

Package: tango-common
Architecture: all
Multi-Arch: foreign
Section: net
Depends: adduser, ${misc:Depends}
Description: TANGO distributed control system - common files
 This package provides shared files for the TANGO distributed control
 system, and sets up the required infrastructure. It is for now an
 empty package

Package: tango-db
Architecture: any
Section: net
Depends: dbconfig-mysql | dbconfig-no-thanks,
         libtango-tools,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: default-mysql-client
Pre-Depends: ${misc:Pre-Depends}
Description: TANGO distributed control system - database server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO database server using MySQL/MariaDB.

Package: tango-starter
Architecture: any
Section: net
Depends: libtango-tools, ${misc:Depends}, ${shlibs:Depends}
# omninotify is not packaged in debian
# There is an archived RFP: https://bugs.debian.org/134449
#Suggests: omninotify
Pre-Depends: ${misc:Pre-Depends}
Description: TANGO distributed control system - starter server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO device control server. It can start, stop,
 or report the status of other TANGO components.

Package: tango-accesscontrol
Architecture: any
Section: net
Depends: libtango-tools,
         tango-db,
         tango-starter,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: TANGO distributed control system - accesscontrol server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO accesscontrol server. It can be used to
 manage the users and IP addresses that are permitted to access TANGO
 devices.

Package: tango-test
Architecture: any
Section: net
Depends: tango-starter, ${misc:Depends}, ${shlibs:Depends}
Description: TANGO distributed control system - test device
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO device which implements all TANGO
 attribute types, and can be used for testing the installation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

CONFIGURE_OPTS :=	-DCMAKE_BUILD_TYPE=Release \
					-DTANGO_OMNI_BASE=/usr \
					-DTSD_JAVA=OFF \
					-DTDB_DATABASE_SCHEMA=OFF \
					-DDB_SCRIPTS=ON \
					-DTSD_TAC=ON

# TODO: handle/remove --disable-jpegmmx

# sphinxdoc is available only when building the arch-all packages
WITH_SPHINXDOC = $(shell if [ -x /usr/bin/dh_sphinxdoc ]; then echo "--with sphinxdoc"; fi)

%:
	dh $@ $(WITH_SPHINXDOC)

# TODO: migrate this target to support cmake
# for trixie (with tango 9.4), this is not super imporant, since 9.3 and 9.4 DBs are compatible
sql:
	dh_auto_configure -- $(CONFIGURE_OPTS)
	# use this target to generate the dbconfig-common upgrade script once the debian/changelog is ok
	cp cppserver/database/update_db_from_9.2.5_to_9.3.4.sql debian/dbconfig-common/data/tango-db/upgrade/mysql/$(DEB_VERSION_UPSTREAM)
	$(MAKE) distclean

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_OPTS)

override_dh_auto_build-indep:
	$(MAKE) -C doc/src/ html

override_dh_auto_install-arch:
	dh_auto_install --destdir="$(CURDIR)/debian/tmp/"
	# install dbconfig-common scripts
	install -d debian/tmp/usr/share/dbconfig-common/data/tango-db/install
	install -p -m 644 debian/tmp/usr/share/tango/db/create_db.sql debian/tmp/usr/share/dbconfig-common/data/tango-db/install/mysql
	install -d debian/tmp/usr/share/
	cp -r debian/dbconfig-common debian/tmp/usr/share
	install -d debian/tmp/usr/lib/tango
	cp debian/tango-starter-register-helper debian/tmp/usr/lib/tango

	# install scripts used during the configuration
	install -d debian/tmp/usr/share/tango-db

override_dh_auto_install-indep:
	# move the built documentation before installing
	# TODO: why?
	-cp -r doc/src/build/html doc/
	install -d debian/tmp/usr/share/doc/tango
	install -d debian/tmp/usr/share/doc/tango/idl/
	-cp -r doc/html debian/tmp/usr/share/doc/tango/

	# install the tango home dir
	install -d debian/tmp/var/lib/tango

override_dh_install:
	# libtango95
	dh_install -p libtango95 usr/lib/*/libtango.so.*

	# libtango-dev
	dh_install -p libtango-dev usr/include/tango/*
	dh_install -p libtango-dev usr/include/tango/idl
	dh_install -p libtango-dev usr/include/tango.idl usr/include/tango/idl/
	dh_install -p libtango-dev usr/lib/*/libtango*.so
	dh_install -p libtango-dev usr/lib/*/pkgconfig/tango.pc
	dh_install -p libtango-dev usr/lib/*/pkgconfig/tangoidl.pc

	# libtango-doc
	dh_install -p libtango-doc usr/share/doc/tango/html
	dh_install -p libtango-doc usr/share/doc/tango

	# libtango-tools
	dh_install -p libtango-tools usr/bin/tango_admin usr/bin

	# tango-common
	dh_install -p tango-common var/lib/tango

	# tango-db
	dh_install -p tango-db usr/bin/Databaseds usr/lib/tango
	dh_install -p tango-db usr/share/tango-db
	dh_install -p tango-db usr/share/dbconfig-common
	dh_install -p tango-db usr/share/tango/db/create_db_tables.sql usr/share/tango-db/
	dh_install -p tango-db usr/share/tango/db/migrate_db_tables_innodb.sql usr/share/tango-db/
	dh_install -p tango-db usr/share/tango/db/stored_proc.sql usr/share/tango-db/

	dh_install -p tango-db usr/share/tango/db/my.cnf usr/share/tango-db/

	# tango-starter
	dh_install -p tango-starter usr/bin/Starter usr/lib/tango
	dh_install -p tango-starter usr/lib/tango/tango-starter-register-helper usr/lib/tango/

	# tango-accesscontrol
	dh_install -p tango-accesscontrol usr/bin/TangoAccessControl usr/lib/tango
	# TODO: ship this? (if yes, need to be removed from debian/not-installed
	# dh_install -p tango-accesscontrol usr/bin/tango_wpa

	# tango-test
	dh_install -p tango-test usr/bin/TangoTest usr/lib/tango

	dh_install -X.la

override_dh_installinit:
	# the tango-accesscontrol device must be started after the tango-db.
	dh_installinit -ptango-accesscontrol --update-rcd-params="defaults 25"
	# the tango-starter device must be started after the tango-db and the tango-accesscontrol.
	dh_installinit -ptango-starter --update-rcd-params="defaults 30"
	dh_installinit -a -Ntango-accesscontrol -Ntango-starter

# Aucun test nécessaire pour la documentation
override_dh_auto_test-indep:
